{***********************************************
 **              Unit AVIFrm                  **
 ** ----------------------------------------- **
 **         Ein kleiner Video-Player          **
 ** ----------------------------------------- **
 **                                           **
 **  Delphi 1.0 / AVIFRM.PAS / Heiko Drner   **
 **      entwickelt am  : 14.04.1995          **
 **      letztes Update : 14.04.1995          **
 **                                           **
 **********************************************}

 {
 Borland; Delphi; Video; AVI; Mediaplayer

 Ein Video-Player fr Windows. Spielt ein
 AVI-Video in Originalgre im Applikations-
 Fenster ab. Bei Doppelklick auf das Video
 erscheint dieses in einem eigenen Video-
 Fenster.

 Das Beispiel soll zeigen, wie man mit mit
 ca. 25 Zeilen Extra-Code eine nette Applikation
 erstellen kann.

 Es handelt sich hierbei um meine erstes Delphi-
 Programm. Man kann natrlich noch einiges
 verbessern, klar. Ich wrde mich ber Post
 (Anregungen, Verbesserungen usw.) von Euch
 freuen.

 Gru Heiko Drner (CID:100570,2660)
 }

unit Avifrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, MPlayer, Menus, Buttons,
  InfoFrm;

const
  ProgName = 'AVI-Player';

type
  TFormMain = class(TForm)
    ImageBackgr: TImage;
    PanelAVI: TPanel;
    MainMenu: TMainMenu;
    MenuDatei: TMenuItem;
    MenuOpen: TMenuItem;
    MenuDummy: TMenuItem;
    MenuQuit: TMenuItem;
    OpenDialog: TOpenDialog;
    PanelStatus: TPanel;
    MediaPlayer: TMediaPlayer;
    BtnInfo: TSpeedButton;
    BtnQuit: TSpeedButton;
    MenInfo: TMenuItem;
    ImageIcon: TImage;
    procedure ShowAVI(FileName: string);
    procedure ShowParamStrAVI;
    procedure MenuOpenClick(Sender: TObject);
    procedure BtnInfoClick(Sender: TObject);
    procedure BtnQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelAVIDblClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

{----------------------------------------------------------
 Zeigt eine AVI-Datei im Panel-Fenster an. }

procedure TFormMain.ShowAVI(FileName: string);
const OffsetLeft = 20;
      OffsetTop  =-45;
var AVIRect,PanelRect:TRect;
begin
  MediaPlayer.Filename:=Filename;
  try
    MediaPlayer.Open;

    { Gre des Videos ermitteln }
    AVIRect:=MediaPlayer.DisplayRect;

    { Video im Panel einfgen }
    MediaPlayer.DisplayRect:=Rect(2,2,0,0);

    { Gre des Panels anpassen und zentrieren }
    PanelRect.Left   :=OffsetLeft+(FormMain.Width-(AviRect.Right-AviRect.Left)) div 2;
    PanelRect.Top    :=OffsetTop +(FormMain.Height-(AviRect.Bottom-AviRect.Top)) div 2;
    PanelRect.Right  :=PanelRect.Left+(AviRect.Right-AviRect.Left)+6;
    PanelRect.Bottom :=PanelRect.Top+(AviRect.Bottom-AviRect.Top) +6;
    PanelAVI.BoundsRect:=PanelRect;

    { Name des Videos in Caption eintragen }
    FormMain.Caption:=ProgName+' ('+ExtractFileName(FileName)+')';

    MediaPlayer.Play;
  except;
  end;
end;

{----------------------------------------------------------
 Kontrolliert, ob ein Video als Kommandozeilenparameter
 bergeben wurde und zeigt ggf. das Video an. }

procedure TFormMain.ShowParamStrAVI;
var FileName: string;
begin
  if ParamCount=1 then begin
    FileName:=ParamStr(1);
    ShowAVI(FileName);
  end;
end;

procedure TFormMain.MenuOpenClick(Sender: TObject);
begin
  if OpenDialog.Execute
  then ShowAVI(OpenDialog.Filename);
end;

procedure TFormMain.BtnInfoClick(Sender: TObject);
begin
  InfoFrm.AboutBox.ShowModal;
end;

procedure TFormMain.BtnQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  ShowParamStrAVI;
end;

procedure TFormMain.PanelAVIDblClick(Sender: TObject);
var AVIRect,PanelRect:TRect;
begin
  { Bei Doppelklick im Fenster kann das Video
    auch im eigenen Fenster laufen }
  if MediaPlayer.Display=nil
  then MediaPlayer.Display:=PanelAVI
  else begin
    PanelAvi.Invalidate;
    MediaPlayer.Display:=nil;
    MediaPlayer.Open;
    MediaPlayer.Play;
  end;
end;

end.
